﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Reflection;
using System.Reflection.Emit;
using System.Runtime.Remoting.Metadata.W3cXsd2001;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Linq;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.Button;

namespace Netzteil_Steuerung
{
      public partial class Form1 : Form
    {
       private SerialPort port = new SerialPort();
        string antwortganz;
        string antwortteil;
        string str = "0";
        string strA = "0";
        string strB = "0";
        int Volt = 0;
        int Ampere = 0;

        public Form1() //Form Inizialization
        {
            InitializeComponent();
        }
        private void button1_Click(object sender, EventArgs e)
        {
            Start();
        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            while (port.BytesToRead > 0)
            {
                try
                {
                    this.Invoke(new EventHandler(DoUpdate));
                }
                catch (Exception ex)
                {
                  MessageBox.Show(ex.Message);
                }
            }
        }
        // Daten in TextBox
        private void DoUpdate(object s, EventArgs e)
        {
            //textBox1.Text = textBox1.Text + port.ReadExisting();

            antwortganz = port.ReadExisting(); ;
            antwortteil = antwortganz.Substring(0, antwortganz.IndexOf('>'));
            textBox1.Text = antwortteil;
            // str = port.ReadExisting();
            if (str == "120") //Spannung
            {
                
                strA = port.ReadExisting();
                textBox1.Clear();
                textBox1.Text = strA;
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.ScrollToCaret();
            }
            if (str == "C400") //Ampere
            {
                
                strB = port.ReadExisting();
                textBox2.Clear();
                textBox2.Text = strB;
                textBox2.SelectionStart = textBox2.Text.Length;
                textBox2.ScrollToCaret();
            }
        }
      private void button2_Click_1(object sender, EventArgs e)
        {
            try
            {
                port.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
      private void Form1_Load(object sender, EventArgs e)
        {
          try
            {
                foreach (string s in SerialPort.GetPortNames())
                {
                    comboBox1.Items.Add(s);
                }
                comboBox1.SelectedIndex = 0;
          }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
       private void Start()
        {
            try
            {
                timer1.Enabled = false;
                port.PortName = "COM4";
                port.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);

                string[] ports = SerialPort.GetPortNames();
                foreach (string port in ports)
                {
                    comboBox1.Items.Add(port);
                }
                port.BaudRate = 9600;
                port.Open();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                timer1.Enabled = false;
                timer2.Enabled = false;
            }
        }
       private void button3_Click(object sender, EventArgs e)
        {
            radioButton1.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
            port.Write("<01003300001>");
          }
       private void button4_Click(object sender, EventArgs e)
        {
            port.Write("<010034500001>");
            radioButton2.Checked = true;
            radioButton1.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button17_Click(object sender, EventArgs e)
        {
            port.Write("<010041500001>");
            radioButton3.Checked = true;
            radioButton2.Checked = false;
            radioButton1.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button5_Click(object sender, EventArgs e)
        {
            port.Write("<010050000001>");
            radioButton4.Checked = true;
            radioButton1.Checked = false;
            radioButton3.Checked = false;
            radioButton2.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button16_Click(object sender, EventArgs e)
        {
            port.Write("<010090000001>");
            radioButton5.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton1.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button6_Click(object sender, EventArgs e)
        {
            port.Write("<0101200000001>");
            radioButton6.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton1.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button7_Click(object sender, EventArgs e)
        {
            port.Write("<0101900000001>");
            radioButton7.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton1.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button8_Click(object sender, EventArgs e)
        {
            port.Write("<010195000001>");
            radioButton8.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton1.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
       private void button21_Click(object sender, EventArgs e)
        {
            port.Write("<010280000001>");
            radioButton18.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton21.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
        }
      private void button9_Click(object sender, EventArgs e)
        {
            port.Write("<03000200000>");
            radioButton9.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton15.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button10_Click(object sender, EventArgs e)
        {
            port.Write("<03000500000>");
            radioButton10.Checked = true;
            radioButton9.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton15.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button11_Click(object sender, EventArgs e)
        {
            port.Write("<03001000000>");
            radioButton11.Checked = true;
            radioButton10.Checked = false;
            radioButton9.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton15.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button12_Click(object sender, EventArgs e)
        {
            port.Write("<03001500000>");
            radioButton12.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton9.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton15.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button13_Click(object sender, EventArgs e)
        {
            port.Write("<03002000000>");
            radioButton13.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton9.Checked = false;
            radioButton14.Checked = false;
            radioButton15.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button14_Click(object sender, EventArgs e)
        {
            port.Write("<03005000000>");
            radioButton14.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton9.Checked = false;
            radioButton15.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button15_Click(object sender, EventArgs e)
        {
            port.Write("<03009999000>");
            radioButton15.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton9.Checked = false;
            radioButton19.Checked = false;
            radioButton20.Checked = false;
        }
      private void button19_Click(object sender, EventArgs e)
        {
            port.Write("<07000000000>");
            radioButton16.Checked = true;
            radioButton17.Checked = false;
            timer2.Enabled = true;
        }
      private void button20_Click(object sender, EventArgs e)
        {
            port.Write("<08000000000>");
            radioButton17.Checked = true;
            radioButton16.Checked = false;
            timer2.Enabled = false;
        }
      private void button22_Click(object sender, EventArgs e)
        {
            port.Write("<03000035000>");
            radioButton19.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton9.Checked = false;
            radioButton15.Checked = false;
            radioButton20.Checked = false;
        }
      private void button23_Click(object sender, EventArgs e)
        {
            port.Write("<03000050000>");
            radioButton20.Checked = true;
            radioButton10.Checked = false;
            radioButton11.Checked = false;
            radioButton12.Checked = false;
            radioButton13.Checked = false;
            radioButton14.Checked = false;
            radioButton9.Checked = false;
            radioButton19.Checked = false;
            radioButton15.Checked = false;
        }
      private void button25_Click(object sender, EventArgs e)
        {
            port.Write("<01001500001>");
            radioButton21.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton1.Checked = false;
            radioButton22.Checked = false;
            radioButton23.Checked = false;
            
        }
      private void button24_Click(object sender, EventArgs e)
        {
            port.Write("<01001900001>");
            radioButton22.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton1.Checked = false;
            radioButton21.Checked = false;
            radioButton23.Checked = false;
        }
      private void button26_Click(object sender, EventArgs e)
        {
            port.Write("<01003000001>");
            radioButton23.Checked = true;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton1.Checked = false;
            radioButton22.Checked = false;
            radioButton21.Checked = false;
        }
      private void button27_Click(object sender, EventArgs e)
        {
            port.Write("<09100000000>");
        }
      private void button28_Click(object sender, EventArgs e)
        {
            port.Write("<09200000000>");
        }
      private void timer2_Tick(object sender, EventArgs e) // Abfragen der Werte
        {
            Volt++;
            Ampere++;

            if (Volt > 5)
            {
                port.Write("<02003300000>");
                Volt = 0;
            }
            if (Ampere > 3)
            {
                port.Write("<04003300000>");
                Ampere = 0;
            }
      }
    }
}